/* Energy Server
 *  Basic mashup of the EMON Arduino Sketch - Current only
 *  https://openenergymonitor.org/emon/buildingblocks/arduino-sketch-current-only
 *  
 *  and the basic Arduino Webserver Arduino Wiznet Ethrenet shield example
 *  
 *  Bernie Kobier 1 May 2016
 */



#include <SPI.h>
#include <Ethernet.h>
#include "EmonLib.h"                   // Include Emon Library
EnergyMonitor emon1;                   // Create 4 instances
EnergyMonitor emon2;
EnergyMonitor emon3;
EnergyMonitor emon4;


// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};
IPAddress ip(192, 168, 1, 177);

// Initialize the Ethernet server library
// with the IP address and port you want to use
// (port 80 is default for HTTP):
EthernetServer server(80);

void setup() {
  // Open serial communications and wait for port to open:
  //Serial.begin(9600);
  //while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only

    
  //}

  // start Energy monitor
  emon1.current(1, 57);             // Current: input pin, calibration.
  emon2.current(2, 57);
  emon3.current(3, 57);
  emon4.current(4, 57);

  
  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  
}


void loop() {
  
  // Output the readings from the energy monitor
         double Irms1 = emon1.calcIrms(1480);  // Calculate Irms only
         double Irms2 = emon2.calcIrms(1480);
         double Irms3 = emon3.calcIrms(1480);
         double Irms4 = emon4.calcIrms(1480);
         int pwrTotal = (Irms1+ Irms2 + Irms3)*240;
         int pwrAvail = (Irms4*240) - pwrTotal;

  
  
  
  
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
        boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        //Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
          client.println("Refresh: 10");  // refresh the page automatically every 5 sec
          client.println();
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");
             
          client.print("Phase 1 ");
          client.print(Irms1*240.0);         // Apparent power
          client.print(" W");
          client.print(" ");
          client.print(Irms1);           // Irms
          client.println(" A");
          client.println("<br />");

          client.print("Phase 2 ");
          client.print(Irms2*240.0);         // Apparent power
          client.print(" W");
          client.print(" ");
          client.print(Irms2);           // Irms
          client.println(" A");
          client.println("<br />");

          client.print("Phase 3 ");
          client.print(Irms3*240.0);         // Apparent power
          client.print(" W");
          client.print(" ");
          client.print(Irms3);           // Irms
          client.println(" A");
          client.println("<br />");

          client.print("Solar  ");
          client.print(Irms4*240.0);         // Apparent power
          client.print(" W");
          client.print(" ");
          client.print(Irms4);           // Irms
          client.println(" A");
          client.println("<br />");
          client.print("Total VA: ");
          client.println(pwrTotal);
          client.println("<br />");
          client.print("Available power  ");
          client.println(pwrAvail);
          client.println("<br />");
          client.print("<p>Power available <meter min=\"0\" max=\"");
          client.print(pwrTotal);
          client.print("\" value=\"");
          client.print(pwrAvail);
          client.print("\"></meter></p>");
          client.println("</html>");
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    //Serial.println("client disconnected");
    Ethernet.maintain();
  }
}
